/*
 * *************************************************
 * Copyright (c) 2018 QMTH. All Rights Reserved.
 * Created by Deason on 2018-11-23 17:52:37.
 * *************************************************
 */

package cn.com.qmth.examcloud.core.print.service;

import cn.com.qmth.examcloud.core.print.service.bean.common.CourseInfo;
import cn.com.qmth.examcloud.core.print.service.bean.common.ExamCourseInfo;
import cn.com.qmth.examcloud.core.print.service.bean.common.ExamInfo;
import cn.com.qmth.examcloud.core.print.service.bean.examquestionstructure.ExamQuestionStructureInfo;

import java.util.List;

/**
 * @author: fengdesheng
 * @since: 2018/11/23
 */
public interface StatisticService {

    /**
     * 获取某考试的课程和试卷类型列表
     */
    List<ExamCourseInfo> findExamCourseAndPaperTypes(Long orgId, Long examId);

    /**
     * 获取考试的实际课程数量
     */
    int countExamTotalCourse(List<ExamCourseInfo> coursePaperTypes);

    /**
     * 获取考试的试卷袋列表
     */
    List<String> findExamPackageCodes(Long orgId, Long examId);

    /**
     * 获取考试的考点列表
     */
    List<String> findExamSites(Long examId);

    /**
     * 获取考试的学习中心列表
     */
    List<Long> findExamLearnCenters(Long examId);

    /**
     * 通过考试获取考生的数量(人科次)
     */
    int countExamTotalStudentByExamId(Long examId);

    /**
     * 通过课程和试卷类型获取考生的数量
     */
    int countExamTotalStudentByCourseIdAndPaperType(Long examId, Long courseId, String paperType);

    /**
     * 通过试卷袋编号获取考生的数量
     */
    int countExamTotalStudentByPackageCode(Long examId, String packageCode);

    /**
     * 通过学习中心获取考生的数量
     */
    int countExamTotalStudentByLearnCenter(Long examId, Long learnCenterId);

    /**
     * 通过考点获取考生的数量
     */
    int countExamTotalStudentBySite(Long examId, String site);

    /**
     * 获取课程基本信息
     */
    CourseInfo findCourseInfo(Long orgId, Long courseId);

    /**
     * 获取考试的试卷试题结构信息
     */
    ExamQuestionStructureInfo findStructureByPaperId(Long examId, String paperId);

    /**
     * 获取传统考试列表
     */
    List<ExamInfo> findTraditionExams();

}